﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace tree
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void filrToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            /*
            ListViewItem item = new ListViewItem();
            item.Text = "item";
            item.SubItems.Add("subitem 1");
            item.SubItems.Add("subitem 2");
            // item.ForeColor = Color.Blue;
            // item.BackColor = Color.Yellow;
            listView1.Items.Add(item);

            TreeNode node = new TreeNode ();
            node.Text = "abc";
            treeView1.Nodes.Add (node);

            TreeNode node2 = new TreeNode();
            node2.Text = "def";
            node.Nodes.Add (node2);

            node.Expand();
            */
            treeView1.ShowNodeToolTips = true;
            // showDir(null, "C:\\Temp");

            // showDir2 (treeView1.Nodes, new DirectoryInfo ("C:\\Program Files"));

            showDrives (treeView1.Nodes);
        }

        private void showDrives (TreeNodeCollection above)
        {
           DriveInfo [] info = DriveInfo.GetDrives ();
           foreach (DriveInfo d in info)
           {
               MyNode node = new MyNode();
               node.path = d.ToString();
               node.Text = d.Name;
               node.ToolTipText = d.ToString();
               above.Add(node);
               showDir2 (node, d.RootDirectory, 1);
           }
        }

        private void showDir2 (MyNode above, 
                               DirectoryInfo dir, 
                               int level)
        {
            try
            {
                above.scanned = true;
                foreach (DirectoryInfo d in dir.GetDirectories())
                {
                    MyNode node = new MyNode();
                    node.path = d.FullName;
                    node.Text = d.Name;
                    node.ToolTipText = d.FullName;

                    above.Nodes.Add(node);
                    if (level > 1)
                        showDir2(node, d, level - 1);
                }
            }
            catch (Exception e)
            {
                TreeNode node = new TreeNode();
                node.Text = e.ToString();
                node.ForeColor = Color.Red;
            }
        }

        private void treeView1_BeforeExpand(object sender, TreeViewCancelEventArgs e)
        {
            // e.Cancel = true;
            MyNode node = e.Node as MyNode;
            if (node != null)
                showDir3 (node, 2); 

        }

        private void showDir3 (MyNode above, int level)
        {
            if (above.scanned)
            {
                if (level > 1)
                    foreach (MyNode n in above.Nodes)
                       showDir3 (n, level - 1);
            }
            else
            {
                showDir2 (above, new DirectoryInfo (above.path), level);
            }
        }

        private void treeView1_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            listView1.Items.Clear ();
            while (tabControl1.TabPages.Count >= 2)
                tabControl1.TabPages.RemoveAt (1);

            MyNode node = e.Node as MyNode;
            if (node != null)
            {
                try
                {
                    DirectoryInfo dir = new DirectoryInfo(node.path);
                    FileInfo[] files = dir.GetFiles();
                    foreach (FileInfo f in files)
                    {
                        ListViewItem item = new ListViewItem();
                        item.Text = f.Name;
                        item.ToolTipText = f.FullName;
                        item.SubItems.Add("" + f.Length);
                        item.SubItems.Add("" + f.LastWriteTime);
                        listView1.Items.Add(item);

                        /*
                        Icon icon = Icon.ExtractAssociatedIcon(f.FullName);
                        imageList1.Images.Add(icon);
                        item.ImageIndex = imageList1.Images.Count;
                         */

                        string key = f.Extension;
                        bool img = false;
                        if (key == ".jpg" || key == ".bmp")
                        {
                            key = f.Name;
                            img = true;
                        }
                        if (!imageList1.Images.ContainsKey(key))
                        {
                            if (!img)
                            {
                                Icon icon = Icon.ExtractAssociatedIcon(f.FullName);
                                imageList1.Images.Add(key, icon);
                            }
                            else
                            {
                                Bitmap p = new Bitmap (f.FullName);
                                Bitmap t = new Bitmap (imageList1.ImageSize.Width,
                                                       imageList1.ImageSize.Height);
                                Graphics g = Graphics.FromImage (t);
                                g.DrawImage (p, 0, 0, t.Width, t.Height);
                                imageList1.Images.Add(key, t);
                            }
                        }
                        item.ImageIndex = imageList1.Images.IndexOfKey(key);
                    }
                }
                catch (Exception ee)
                {
                    ListViewItem item = new ListViewItem ();
                    item.Text = ee.ToString();
                    item.ForeColor = Color.Red;
                }
            }
        }


        private void showDir(TreeNode above, string path)
        {
            // using System.IO;
            DirectoryInfo dir = new DirectoryInfo (path);
            DirectoryInfo [] info = dir.GetDirectories ();

            foreach (DirectoryInfo d in info)
            { 
                TreeNode node = new TreeNode ();
                node.Text = d.Name;
                node.ToolTipText = d.FullName;

                if (above == null)
                    treeView1.Nodes.Add(node);
                else
                    above.Nodes.Add(node);

                showDir(node, d.FullName);
            }
        }

        private void treeView1_NodeMouseDoubleClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            // e.Node.BackColor = Color.Red;
        }

        private void listView1_DoubleClick(object sender, EventArgs e)
        {
            foreach (ListViewItem item in listView1.SelectedItems)
            {
                String s = item.ToolTipText;
                TabPage page = new TabPage();
                page.Text = s;
                tabControl1.TabPages.Add(page);

                if (s.EndsWith(".jpg") || s.EndsWith(".bmp"))
                {
                    Panel p = new Panel();
                    p.Parent = page;
                    p.Dock = DockStyle.Fill;
                    p.BackgroundImage = new Bitmap(s);
                }
                else if (s.EndsWith(".html") || s.EndsWith(".java"))
                {
                    WebBrowser b = new WebBrowser();
                    b.Parent = page;
                    b.Dock = DockStyle.Fill;
                    b.Url = new Uri ("file://" + s);
                }

            }
        }


    }
}
